/*============================================================================
                      LISTS of PAIRS of INTEGERS
It implements STACKS of pairs of integers. After a L.tail() operation, the
element L.head() of the list L is no longer linked to the tail of L.
=========================================================================== */
#include  <iostream.h>
//----------------------------------------------------------------------------
//                    PAIRS of INTEGERS
class intpair {int f, s;
 public :
 intpair(int a, int b) {f=a; s=b;}
 int intf(){return f;}
 int ints(){return s;}
};
//----------------------------------------------------------------------------
//                    TEMPLATE for LISTS of TYPE T
template<class T> class List
{struct cell
   {T atom; cell* next;
    cell(T at, cell* nx) : atom(at), next(nx) { };};
    cell* ptr;
public :
List(): ptr(NULL){}

T head()
{if (ptr == NULL) {cout << "\nError: head of empty list \n";}
 else {return ptr->atom;} }

void tail()
{if (ptr == NULL) {cout << "\nError: tail of empty list \n";}
else {ptr=ptr->next;} }

void cons(T x) {ptr = new cell(x,ptr);}

void pprintlist()
{if (ptr == NULL) {cout << "nil";}
 else {intpair ip=ptr->atom;cout <<"("<<ip.intf()<<","<<ip.ints()<<") ";
       cell* ptr1=ptr; ptr=ptr->next; pprintlist(); ptr=ptr1;}}
};    // end of template List<T>
//----------------------------------------------------------------------------
void main()
{List<intpair> l1; cout << "nil = "; l1.pprintlist();
intpair d1=intpair(1,2); intpair d2=intpair(3,4); intpair d3=intpair(5,6);
cout << "\n"; l1.cons(d1);l1.cons(d2);l1.cons(d3);
l1.pprintlist();
l1.tail();cout<<"\n";l1.pprintlist();
intpair ip=l1.head(); cout <<"\n("<<ip.intf()<<","<<ip.ints()<<")\n";
}
/* input:   output:
------------------------------------------------------------------------------
            nil = nil
            (5,6) (3,4) (1,2) nil
            (3,4) (1,2) nil
            (3,4)
--------------------------------------------------------------------------- */